
.586p
.model flat
option scoped



include rasm.inc






ut_shade_bits equ 6

.data

extern _cur_end_span : dword
extern _cur_span     : dword

extern _cur_solid_clut : dword



align 4


U_BITS equ 5
max_x_res  equ 1024
uv_fx_bits equ 20


span_block_bits equ 3
span_block_size equ (1 shl span_block_bits)
span_block_frac equ (span_block_size-1)


extern 	_cur_end_span : dword
extern 	_cur_span : dword



block_datas equ ?block_datas@@3PAUblock_data@@A
start_block equ ?start_block@@3PAUblock_data@@A
end_block   equ ?end_block@@3PAUblock_data@@A

extrn block_datas : dword

extrn start_block : dword
extrn end_block : dword





cur_scaled_y dd ?
end_point_esp  dd ?
esp_line_start dd ?
cur_x_block  dd ?


externdef tmap_low_masks  : byte
externdef tmap_high_masks : byte











.code

draw_sb_asm_start_1:
public C draw_sb_asm_start_1;







































;
; ecx = y
; edx =	span *
;

; during inner loop
   ; edi  -dx
   ; esp  screen pointer
   ; ebx  temp for tex gen
   ; eax  temp out pixel
   ; esi   u (high)   v (low)
   ; ecx  du (high)  dv (low)
   ; edx   v (high)	  shade (low)
   ; ebp  dv (high)	 dshade (low)



draw_span_16 macro span_block_bits, span_block_bits_m1 , has_tp

local  BLK_CLUT_0,BLK_CLUT_1,BLK_SHADE_BITS_0,BLK_SHADE_BITS_1
local  BLK_TMAP_0,BLK_TMAP_1,BLK_ROL_BITS_0,BLK_ROL_BITS_1
local  BLK_MASK_0,BLK_MASK_1,BLK_MASK_1t,BLK_MASK_2,BLK_MASK_3,BLK_MASK_3t 
local  span_block_size, span_block_frac
local  set_asm_name, draw_block_name

if( has_tp )

draw_block_init_name  equ ?draw_block_init@?$p_drawer_sb@$0&span_block_bits_m1&$00@@SIXPBUtexture@raster@@@Z
draw_block_name       equ ?draw_block@?$p_drawer_sb@$0&span_block_bits_m1&$00@@SIHH@Z

else

draw_block_init_name  equ ?draw_block_init@?$p_drawer_sb@$0&span_block_bits_m1&$0A@@@SIXPBUtexture@raster@@@Z
draw_block_name       equ ?draw_block@?$p_drawer_sb@$0&span_block_bits_m1&$0A@@@SIHH@Z 


endif


span_block_size equ (1 shl span_block_bits)
span_block_frac equ (span_block_size-1)








;
; ecx = tmap
;

; only call if tmap is different


draw_block_init_name proc public

 push ebx
  

    mov ebx, [ecx ].texture.clut

    mov dword ptr [BLK_CLUT_0-4], ebx;
    mov dword ptr [BLK_CLUT_1-4], ebx;

 	mov ebx, [ecx].texture.map;	 get map part


	; these are all probably misaligned writes..
	mov dword ptr [BLK_TMAP_0-4], ebx;
	mov dword ptr [BLK_TMAP_1-4], ebx;

	mov ebx, [ecx+4];	get u,v bits
	mov dl, 8;
	mov dh,  [ecx+4+2]; get shade bits 
	sub dl,dh
	
	mov byte ptr [ BLK_SHADE_BITS_0 - 1], dl
	mov byte ptr [ BLK_SHADE_BITS_1 - 1], dl
	

	xor edx,edx;


	mov byte ptr [ BLK_ROL_BITS_0 - 1], bl
	mov byte ptr [ BLK_ROL_BITS_1 - 1], bl
	

    mov dl, bh;
    and ebx,0000000ffh; 
	
	mov bl, tmap_high_masks[ebx]
	mov bh, tmap_low_masks[edx]

	ror ebx, 8;

	mov dword ptr [BLK_MASK_0-4], ebx;
	mov dword ptr [BLK_MASK_1-4], ebx;
	mov dword ptr [BLK_MASK_2-4], ebx;
	mov dword ptr [BLK_MASK_3-4], ebx;

if( has_tp )
	mov dword ptr [BLK_MASK_1t-4], ebx;
	mov dword ptr [BLK_MASK_3t-4], ebx;
endif



 pop ebx
 ret

draw_block_init_name endp








draw_block_name proc public

	push esi
    push ebp
    
	push edi
    push ebx
 	
	mov  [_esp_save], esp;
 	

	mov esp, fb_starts[ecx*4];
	mov [esp_line_start], esp;
	inc ecx                 ;  advance to next line
	shl ecx, 20             ;  scale

	mov eax, [start_block];	  reset
	mov [cur_x_block], eax;

    mov [cur_scaled_y], ecx ;  save
	mov eax, [_cur_span]; load 


 next_span:

	mov [_cur_span], eax;   save
    mov edx, [eax];	 deref span
	mov	eax, [cur_scaled_y];  get y
	mov esp, [esp_line_start];

	cmp edx, eax;			 are we on the same y?
	jge finished_y;
	
	 
	mov ebp, edx; copy for x1;
	mov ebx, edx; copy for x0 fraction;
	
	shr edx, 10;
	and edx, 1023;

	lea edx, [esp + edx*2] ;  find end point of this span
	
	mov [end_point_esp], edx; save for later

	and ebp, max_x_res- 1 -span_block_frac;       find start point and block id

	lea esp, [esp + ebp*2 + span_block_size*2];	advance to start +  span_block_size 

	lea ebp, block_datas[ebp*( 1 shl (4 - span_block_bits) ) ] 
	
	mov eax, [cur_x_block];
	
	cmp eax,ebp;
	jle pre_skip_d_dy;
	
	; get old values. we need to back track by 1 y
	
	mov edx, [ eax    -16 ]   ;  get low uvs
    mov edi, [ eax +8 -16 ]	; get low  d_dy 
  
    sub edx, edi       ;  update
    mov esi, [eax +4  - 16];  get  high uvs
    mov edi, [eax +8+4- 16 ];  get  high  d_dy

    sbb esi, edi

	jmp pre_skip_d_dy_finished;
	

	pre_skip_d_dy:

	mov edx, [ eax    ]   ;  get low uvs
    mov edi, [ eax +8 ]	; get low  d_dy 
  
    add edi, edx       ;  update
    mov esi, [ eax +4 ];  get  high uvs

    mov [ eax ], edi ;   store new low uvs
    mov edi, [eax +8+4 ];  get  high  d_dy
  
    adc edi, esi;
    cmp  eax,ebp;
	
    mov [ eax + 4 ], edi; store new high uvs
	lea eax,[eax+16];

	jl  pre_skip_d_dy;




	;
	; load uvs data
	;
   ; esi   u (high)   v (low)
   ; ecx  du (high)  dv (low)
   ; edx   v (high)	  shade (low)
   ; ebp  dv (high)	 dshade (low)



  
  pre_skip_d_dy_finished:

  mov ebp, [ eax  ]	; get next low uvs
  mov ecx, [ eax+ 4 ]; get next high uvs


 ; find difference for delta
 
  sub ebp, edx;
  mov edi, edx;  make copy of low

  sbb ecx, esi;

  shl esi, span_block_bits;   mult high by 16
  mov [cur_x_block], eax;	save block

  shr edi, 32-span_block_bits;  get carry
  mov eax, [end_point_esp];
  
  shl edx, span_block_bits;
  or esi, edi;	sub in carry
  
  mov edi, -span_block_size*2;   span_block_size more pixels to go
  and bl, span_block_frac;


  jz  pre_step_finished;

	; update values
	
	pre_step_loop : 

	add edi,2
	add edx, ebp;

	adc esi, ecx;
	dec bl;

	jg pre_step_loop;
	pre_step_finished:



	sub eax, esp;	is this the last block?
	jl last_block;
	
	jmp block_loop;





block_loop:



mov ebx, esi;    make copy		
xor eax,eax;

and ebx,  (31 shl (32-5) ) + 31 
BLK_MASK_0::


PUT_LOOP:

 rol ebx, U_BITS;
 BLK_ROL_BITS_0::
 add edx, ebp; inc color, plus update carry flag for v


 adc esi, ecx ;  increment u,v, bring carry from color
 mov al, dh; get shade

 
 mov ah, 0dadadadah[ebx] ; get texture
BLK_TMAP_0::
 mov ebx, esi;	copy

if( has_tp )
cmp ah, 0
sb_tp_index_0&span_block_bits& ::
public C sb_tp_index_0&span_block_bits& ;

je dont_put;
endif


 shr eax, 2;
BLK_SHADE_BITS_0::
 and ebx,  (31 shl (32-5) ) + 31 
BLK_MASK_1::


 mov ax, _clut[eax*2];
BLK_CLUT_0::
 add edi,2;


 mov [esp + edi -2],ax; store into mem
 jl  PUT_LOOP;	still have pixels to draw


if( has_tp )

 dont_put:

 and ebx,  (31 shl (32-5) ) + 31 
BLK_MASK_1t::

 add edi,2;
 jl  PUT_LOOP;	still have pixels to draw

endif



 PUT_LOOP_FINISHED:

  ;
  ;	free : ebx, eax, edi
  ;
  ; eax : block ptr
  mov eax, [cur_x_block];
  lea esp, [esp + span_block_size*2]; next block

  ; agi

  mov edx, [ eax    ]   ;  get low uvs
  mov ebx, [ eax +8 ]	  ; get low  d_dy 
  

  add ebx, edx       ;  update
  mov esi, [ eax +4 ];  get  high uvs

  mov [ eax ], ebx ;   store new low uvs
  mov ebx, [ eax +8+4 ];  get  high  d_dy
  
  adc ebx, esi;
  mov ebp, [ eax+16  ]	; get next low uvs

  mov [ eax + 4 ], ebx; store new high uvs
  mov ecx, [ eax+16 + 4 ]; get next high uvs


  sub ebp, edx;
  mov ebx, edx;  make copy of low

  sbb ecx, esi;
  add eax, 16;  next block

  shl esi, span_block_bits;   mult high by 16
  mov [cur_x_block], eax;	save block

  shr ebx, 32-span_block_bits;  get carry
  mov eax, [end_point_esp];
  
  shl edx, span_block_bits;
  or esi, ebx;	sub in carry
  
  mov edi, -span_block_size*2;   span_block_size more pixels to go
  sub eax, esp;	is this the last block?
  
  jle last_block;
  
  jmp block_loop;




last_block:

 add esp, eax; move esp back
 sub edi, eax; move forward

 jge finished_span
; jg error




 mov ebx, esi;    make copy		
 xor eax,eax;



and ebx,  (31 shl (32-5) ) + 31 
BLK_MASK_2::



LAST_PUT_LOOP:

 rol ebx, U_BITS;
 BLK_ROL_BITS_1::
 add edx, ebp; inc color, plus update carry flag for v


 adc esi, ecx ;  increment u,v, bring carry from color
 mov al, dh; get shade

 
 mov ah, 0dadadadah[ebx] ; get texture
BLK_TMAP_1::
 mov ebx, esi;	copy

if( has_tp )
cmp ah, 0
sb_tp_index_1&span_block_bits& ::
public C sb_tp_index_1&span_block_bits& ;

je dont_put_last;
endif


 shr eax, 2;
BLK_SHADE_BITS_1::
 and ebx,  (31 shl (32-5) ) + 31 
BLK_MASK_3::


 mov ax, _clut[eax*2];
BLK_CLUT_1::
 add edi,2;

 mov [esp + edi -2],ax; store into mem
 jl  LAST_PUT_LOOP;	still have pixels to draw
 


if( has_tp )
 dont_put_last:

 and ebx,  (31 shl (32-5) ) + 31 
BLK_MASK_3t::

 add edi,2;
 jl  LAST_PUT_LOOP;	still have pixels to draw

endif




LAST_PUT_LOOP_FINISHED:

finished_span:

 mov eax, [_cur_span]
 mov edx, [_cur_end_span]
 
 add eax, 4 ; next data
 cmp edx, eax;
 je  finished_spans;

 ; are we at the end of a block?
 test al, 63
 jz  next_span_block;

 jmp next_span;

 next_span_block:

 mov eax, [eax - 64]; get next block
 jmp next_span;

finished_spans:
 
 mov esp, [_esp_save];
 xor eax, eax;
 
 inc eax;
 nop

  pop ebx
  pop edi
  pop ebp
  pop esi
 
  ret



 finished_y:

   mov eax, [cur_x_block];
   mov esp, [_esp_save];
   
   mov edi, [end_block];
   nop
   ; agi
 step_d_dy_next:
   ; last update
  mov edx, [ eax    ]   ;  get low uvs
  mov ebx, [ eax +8 ]	  ; get low  d_dy 
 
  add ebx, edx       ;  update
  mov edx, [ eax +4 ];  get  high uvs

  mov [ eax ], ebx ;   store new low uvs
  mov ebx, [ eax +8+4 ];  get  high  d_dy
  
  adc ebx, edx;
  cmp  eax,edi;

  mov [ eax + 4 ], ebx; store new high uvs
  lea eax, [eax+16];

  jl step_d_dy_next;

  xor eax, eax;
  
  pop ebx
  pop edi
  pop ebp
  pop esi
 
  ret


 error:
 int 3 
 int 3 
 int 3 



draw_block_name endp




endm



draw_span_16 4 , 3 , 0
draw_span_16 3 , 2 , 0
draw_span_16 2 , 1 , 0

draw_span_16 4 , 3 , 1
draw_span_16 3 , 2 , 1
draw_span_16 2 , 1 , 1








draw_sb_asm_end_1:
public C draw_sb_asm_end_1;

end

























 


;
; ecx = y
; edx =	span *
;

; during inner loop
   ; edi  -dx
   ; esp  screen pointer
   ; ebx  temp for tex gen
   ; eax  temp out pixel
   ; esi   u (high)   v (low)
   ; ecx  du (high)  dv (low)
   ; edx   v (high)	  shade (low)
   ; ebp  dv (high)	 dshade (low)



 @draw_span_block_solid@4 proc public

	push esi
    push ebp
    
	push edi
    push ebx
 	
	mov  [_esp_save], esp;
 	

	mov esp, fb_starts[ecx*4];
	mov [esp_line_start], esp;
	inc ecx                 ;  advance to next line
	shl ecx, 20             ;  scale

	mov eax, [start_block];	  reset
	mov [cur_x_block], eax;

    mov [cur_scaled_y], ecx ;  save
	mov eax, [_cur_span]; load 


 next_span:

	mov [_cur_span], eax;   save
    mov edx, [eax];	 deref span
	mov	eax, [cur_scaled_y];  get y
	mov esp, [esp_line_start];

	cmp edx, eax;			 are we on the same y?
	jge finished_y;
	
	 
	mov ebp, edx; copy for x1;
	mov ebx, edx; copy for x0 fraction;
	
	shr edx, 10;
	and edx, 1023;

	lea edx, [esp + edx*2] ;  find end point of this span
	
	mov [end_point_esp], edx; save for later

	and ebp, max_x_res- 1 -span_block_frac;       find start point and block id

	lea esp, [esp + ebp*2 + span_block_size*2];	advance to start +  span_block_size 

	lea ebp, block_datas[ebp*( 1 shl (4 - span_block_bits) ) ] 

;	add ebp, offset block_datas
	
	mov eax, [cur_x_block];
	
	cmp eax,ebp;
	jle pre_skip_d_dy;
	
	; get old values. warning: these are not accurate! (they are off by 1 y)
    mov edx, [ eax -16 ]   ;  get low uvs
	mov edi  [ eax +8 - 16 ];
	sub edx, edi;

	jmp pre_skip_d_dy_finished
	

	pre_skip_d_dy:

	mov edx, [ eax    ]   ;  get low uvs
    mov edi, [ eax +8 ]	; get low  d_dy 
  
    add edi, edx       ;  update
  
    mov [ eax ], edi ;   store new low uvs
  
    cmp  eax,ebp;
	
  	lea eax,[eax+16];

	jl  pre_skip_d_dy;

	pre_skip_d_dy_finished:


	;
	; load uvs data
	;
   ; esi   u (high)   v (low)
   ; ecx  du (high)  dv (low)
   ; edx   v (high)	  shade (low)
   ; ebp  dv (high)	 dshade (low)





  mov ebp, [ eax  ]	; get next low uvs

 ; find difference for delta
 
  sub ebp, edx;

  mov [cur_x_block], eax;	save block

  mov eax, [end_point_esp];
  
  sar ebp, 2;
  shl edx, span_block_bits-2;
  
  mov edi, -span_block_size*2;   span_block_size more pixels to go
  and bl, span_block_frac;

  jz  pre_step_finished;

	; update values
	
	pre_step_loop : 

	add edi,2
	add edx, ebp;

	dec bl;

	jg pre_step_loop;
	pre_step_finished:



	sub eax, esp;	is this the last block?
	jl last_block;
	
	jmp block_loop;





block_loop:


 xor ebx,ebx;
 mov ecx, _cur_solid_clut

PUT_LOOP:

 mov bl,  dh;   get shade
 add edx, ebp;  update

 mov ax,  [ ecx + ebx*2 ];  get pixel
 add edi,2;

 mov [esp + edi -2],ax; store into mem
 jl  PUT_LOOP;	still have pixels to draw



 PUT_LOOP_FINISHED:

  ;
  ;	free : ebx, eax, edi
  ;
  ; eax : block ptr
  mov eax, [cur_x_block];
  lea esp, [esp + span_block_size*2]; next block

  ; agi

  mov edx, [ eax    ]   ;  get low uvs
  mov ebx, [ eax +8 ]	  ; get low  d_dy 
  

  add ebx, edx       ;  update

  mov [ eax ], ebx ;   store new low uvs
  
  mov ebp, [ eax+16  ]	; get next low uvs


  sub ebp, edx;

  add eax, 16;  next block

  mov [cur_x_block], eax;	save block
 
  sar ebp,  2;  get carry
 
  mov eax, [end_point_esp];
  
  shl edx, span_block_bits - 2;
  
  mov edi, -span_block_size*2;   span_block_size more pixels to go
  sub eax, esp;	is this the last block?
  
  jle last_block;
  
  jmp block_loop;




last_block:

 add esp, eax; move esp back
 sub edi, eax; move forward

 jge finished_span
; jg error




 xor ebx,ebx;
 mov ecx, _cur_solid_clut


LAST_PUT_LOOP:

 mov bl,  dh;   get shade
 add edx, ebp;  update

 mov ax,  [ ecx + ebx*2 ];  get pixel
 add edi,2;

 mov [esp + edi -2],ax; store into mem
 jl  LAST_PUT_LOOP;	still have pixels to draw


 
LAST_PUT_LOOP_FINISHED:

finished_span:

 mov eax, [_cur_span]
 mov edx, [_cur_end_span]
 
 add eax, 4 ; next data
 cmp edx, eax;
 je  finished_spans;

 ; are we at the end of a block?
 test al, 63
 jz  next_span_block;

 jmp next_span;

 next_span_block:

 mov eax, [eax - 64]; get next block
 jmp next_span;

finished_spans:
 
 mov esp, [_esp_save];
 xor eax, eax;
 
 inc eax;
 nop

  pop ebx
  pop edi
  pop ebp
  pop esi
 
  ret



 finished_y:

   mov eax, [cur_x_block];
   mov esp, [_esp_save];
   
   mov edi, [end_block];
   nop
   ; agi
 step_d_dy_next:
   ; last update
  mov edx, [ eax    ]   ;  get low uvs
  mov ebx, [ eax +8 ]	  ; get low  d_dy 
 
  add ebx, edx       ;  update

  mov [ eax ], ebx ;   store new low uvs
  
  cmp  eax,edi;

  lea eax, [eax+16];

  jl step_d_dy_next;

  xor eax, eax;
  
  pop ebx
  pop edi
  pop ebp
  pop esi
 
  ret


 error:
 int 3 
 int 3 
 int 3 



@draw_span_block_solid@4 endp





